/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _CONTACTMEDIUM_H_
#define _CONTACTMEDIUM_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class Role;
    class Email;
    class Message;

}

#include "resource.h"

namespace NepomukFast {

    /**
     * A superclass for all contact media - ways to contact an entity 
     * represented by a Contact instance. Some of the subclasses of 
     * this class (the various kinds of telephone numbers and postal 
     * addresses) have been inspired by the values of the TYPE parameter 
     * of ADR and TEL properties defined in RFC 2426 sec. 3.2.1. and 
     * 3.3.1 respectively. Each value is represented by an appropriate 
     * subclass with two major exceptions TYPE=home and TYPE=work. 
     * They are to be expressed by the roles these contact media are 
     * attached to i.e. contact media with TYPE=home parameter are 
     * to be attached to the default role (nco:Contact or nco:PersonContact), 
     * whereas media with TYPE=work parameter should be attached 
     * to nco:Affiliation or nco:OrganizationContact. 
     */
    class ContactMedium : public NepomukFast::Resource
    {
    public:
        /**
         * Create a new empty and invalid ContactMedium instance
         */
        ContactMedium( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'contactMediumComment'. A comment about the 
         * contact medium. (Deprecated in favor of nie:comment or nao:description 
         * - based on the context) 
         */
        void setContactMediumComments( const QStringList& value );

        /**
         * Add a value to property 'contactMediumComment'. A comment 
         * about the contact medium. (Deprecated in favor of nie:comment 
         * or nao:description - based on the context) 
         */
        void addContactMediumComment( const QString& value );

        /**
         * \return The URI of the property 'contactMediumComment'. 
         */
        static QUrl contactMediumCommentUri();



    protected:
        ContactMedium( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
