/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _DATAOBJECT_H_
#define _DATAOBJECT_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class InformationElement;
    class DataSource;
    class Contact;
    class Resource;
    class OrganizationContact;

}

#include "resource.h"

namespace NepomukFast {

    /**
     * A unit of data that is created, annotated and processed on the 
     * user desktop. It represents a native structure the user works 
     * with. The usage of the term 'native' is important. It means that 
     * a DataObject can be directly mapped to a data structure maintained 
     * by a native application. This may be a file, a set of files or a 
     * part of a file. The granularity depends on the user. This class 
     * is not intended to be instantiated by itself. Use more specific 
     * subclasses. 
     */
    class DataObject : public NepomukFast::Resource
    {
    public:
        /**
         * Create a new empty and invalid DataObject instance
         */
        DataObject( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'modified'. Date the DataObject was changed in 
         * any way. Note that this date refers to the modification of the 
         * DataObject itself (i.e. the physical representation). Compare 
         * with nie:contentModified. 
         */
        void setModifieds( const QList<QDateTime>& value );

        /**
         * Add a value to property 'modified'. Date the DataObject was 
         * changed in any way. Note that this date refers to the modification 
         * of the DataObject itself (i.e. the physical representation). 
         * Compare with nie:contentModified. 
         */
        void addModified( const QDateTime& value );

        /**
         * \return The URI of the property 'modified'. 
         */
        static QUrl modifiedUri();

        /**
         * Set property 'created'. Date of creation of the DataObject. 
         * Note that this date refers to the creation of the DataObject 
         * itself (i.e. the physical representation). Compare with nie:contentCreated. 
         */
        void setCreateds( const QList<QDateTime>& value );

        /**
         * Add a value to property 'created'. Date of creation of the DataObject. 
         * Note that this date refers to the creation of the DataObject 
         * itself (i.e. the physical representation). Compare with nie:contentCreated. 
         */
        void addCreated( const QDateTime& value );

        /**
         * Set property 'created'. Date of creation of the DataObject. 
         * Note that this date refers to the creation of the DataObject 
         * itself (i.e. the physical representation). Compare with nie:contentCreated. 
         */
        void setCreated( const QDateTime& value );

        /**
         * \return The URI of the property 'created'. 
         */
        static QUrl createdUri();

        /**
         * Set property 'lastModified'. Last modification date of the 
         * DataObject. Note that this date refers to the modification 
         * of the DataObject itself (i.e. the physical representation). 
         * Compare with nie:contentLastModified. 
         */
        void setLastModifieds( const QList<QDateTime>& value );

        /**
         * Add a value to property 'lastModified'. Last modification 
         * date of the DataObject. Note that this date refers to the modification 
         * of the DataObject itself (i.e. the physical representation). 
         * Compare with nie:contentLastModified. 
         */
        void addLastModified( const QDateTime& value );

        /**
         * Set property 'lastModified'. Last modification date of the 
         * DataObject. Note that this date refers to the modification 
         * of the DataObject itself (i.e. the physical representation). 
         * Compare with nie:contentLastModified. 
         */
        void setLastModified( const QDateTime& value );

        /**
         * \return The URI of the property 'lastModified'. 
         */
        static QUrl lastModifiedUri();

        /**
         * Set property 'interpretedAs'. Links the DataObject with the 
         * InformationElement it is interpreted as. 
         */
        void setInterpretedAses( const QList<InformationElement>& value );

        /**
         * Add a value to property 'interpretedAs'. Links the DataObject 
         * with the InformationElement it is interpreted as. 
         */
        void addInterpretedAs( const InformationElement& value );

        /**
         * \return The URI of the property 'interpretedAs'. 
         */
        static QUrl interpretedAsUri();

        /**
         * Set property 'isPartOf'. Generic property used to express 
         * containment relationships between DataObjects. NIE extensions 
         * are encouraged to provide more specific subproperties of this 
         * one. It is advisable for actual instances of DataObjects to 
         * use those specific subproperties. Note to the developers: 
         * Please be aware of the distinction between containment relation 
         * and provenance. The isPartOf relation models physical containment, 
         * a nie:DataObject (e.g. an nfo:Attachment) is a 'physical' 
         * part of an nie:InformationElement (a nmo:Message). Also, 
         * please note the difference between physical containment (isPartOf) 
         * and logical containment (isLogicalPartOf) the former has 
         * more strict meaning. They may occur independently of each other. 
         */
        void setIsPartOfs( const QList<InformationElement>& value );

        /**
         * Add a value to property 'isPartOf'. Generic property used to 
         * express containment relationships between DataObjects. 
         * NIE extensions are encouraged to provide more specific subproperties 
         * of this one. It is advisable for actual instances of DataObjects 
         * to use those specific subproperties. Note to the developers: 
         * Please be aware of the distinction between containment relation 
         * and provenance. The isPartOf relation models physical containment, 
         * a nie:DataObject (e.g. an nfo:Attachment) is a 'physical' 
         * part of an nie:InformationElement (a nmo:Message). Also, 
         * please note the difference between physical containment (isPartOf) 
         * and logical containment (isLogicalPartOf) the former has 
         * more strict meaning. They may occur independently of each other. 
         */
        void addIsPartOf( const InformationElement& value );

        /**
         * \return The URI of the property 'isPartOf'. 
         */
        static QUrl isPartOfUri();

        /**
         * Set property 'lastRefreshed'. Date when information about 
         * this data object was retrieved (for the first time) or last refreshed 
         * from the data source. This property is important for metadata 
         * extraction applications that don't receive any notifications 
         * of changes in the data source and have to poll it regularly. This 
         * may lead to information becoming out of date. In these cases 
         * this property may be used to determine the age of data, which 
         * is an important element of it's dependability. 
         */
        void setLastRefresheds( const QList<QDateTime>& value );

        /**
         * Add a value to property 'lastRefreshed'. Date when information 
         * about this data object was retrieved (for the first time) or 
         * last refreshed from the data source. This property is important 
         * for metadata extraction applications that don't receive any 
         * notifications of changes in the data source and have to poll 
         * it regularly. This may lead to information becoming out of date. 
         * In these cases this property may be used to determine the age 
         * of data, which is an important element of it's dependability. 
         */
        void addLastRefreshed( const QDateTime& value );

        /**
         * Set property 'lastRefreshed'. Date when information about 
         * this data object was retrieved (for the first time) or last refreshed 
         * from the data source. This property is important for metadata 
         * extraction applications that don't receive any notifications 
         * of changes in the data source and have to poll it regularly. This 
         * may lead to information becoming out of date. In these cases 
         * this property may be used to determine the age of data, which 
         * is an important element of it's dependability. 
         */
        void setLastRefreshed( const QDateTime& value );

        /**
         * \return The URI of the property 'lastRefreshed'. 
         */
        static QUrl lastRefreshedUri();

        /**
         * Set property 'dataSource'. Marks the provenance of a DataObject, 
         * what source does a data object come from. 
         */
        void setDataSources( const QList<DataSource>& value );

        /**
         * Add a value to property 'dataSource'. Marks the provenance 
         * of a DataObject, what source does a data object come from. 
         */
        void addDataSource( const DataSource& value );

        /**
         * \return The URI of the property 'dataSource'. 
         */
        static QUrl dataSourceUri();

        /**
         * Set property 'coreGraph'. Connects the data object with the 
         * graph that contains information about it. Deprecated in favor 
         * of a more generic nao:isDataGraphFor. 
         */
        void setCoreGraphs( const QList<Resource>& value );

        /**
         * Add a value to property 'coreGraph'. Connects the data object 
         * with the graph that contains information about it. Deprecated 
         * in favor of a more generic nao:isDataGraphFor. 
         */
        void addCoreGraph( const Resource& value );

        /**
         * \return The URI of the property 'coreGraph'. 
         */
        static QUrl coreGraphUri();

        /**
         * Set property 'byteSize'. The overall size of the data object 
         * in bytes. That means the space taken by the DataObject in its 
         * container, and not the size of the content that is of interest 
         * to the user. For cases where the content size is different (e.g. 
         * in compressed files the content is larger, in messages the content 
         * excludes headings and is smaller) use more specific properties, 
         * not necessarily subproperties of this one. 
         */
        void setByteSizes( const QList<qint64>& value );

        /**
         * Add a value to property 'byteSize'. The overall size of the data 
         * object in bytes. That means the space taken by the DataObject 
         * in its container, and not the size of the content that is of interest 
         * to the user. For cases where the content size is different (e.g. 
         * in compressed files the content is larger, in messages the content 
         * excludes headings and is smaller) use more specific properties, 
         * not necessarily subproperties of this one. 
         */
        void addByteSize( const qint64& value );

        /**
         * Set property 'byteSize'. The overall size of the data object 
         * in bytes. That means the space taken by the DataObject in its 
         * container, and not the size of the content that is of interest 
         * to the user. For cases where the content size is different (e.g. 
         * in compressed files the content is larger, in messages the content 
         * excludes headings and is smaller) use more specific properties, 
         * not necessarily subproperties of this one. 
         */
        void setByteSize( const qint64& value );

        /**
         * \return The URI of the property 'byteSize'. 
         */
        static QUrl byteSizeUri();

        /**
         * Set property 'url'. URL of a DataObject. It points to the location 
         * of the object. A typial usage is FileDataObject. In cases where 
         * creating a simple file:// or http:// URL for a file is difficult 
         * (e.g. for files inside compressed archives) the applications 
         * are encouraged to use conventions defined by Apache Commons 
         * VFS Project at http://jakarta.apache.org/ commons/ vfs/ 
         * filesystems.html. 
         */
        void setUrls( const QList<Resource>& value );

        /**
         * Add a value to property 'url'. URL of a DataObject. It points 
         * to the location of the object. A typial usage is FileDataObject. 
         * In cases where creating a simple file:// or http:// URL for a 
         * file is difficult (e.g. for files inside compressed archives) 
         * the applications are encouraged to use conventions defined 
         * by Apache Commons VFS Project at http://jakarta.apache.org/ 
         * commons/ vfs/ filesystems.html. 
         */
        void addUrl( const Resource& value );

        /**
         * Set property 'url'. URL of a DataObject. It points to the location 
         * of the object. A typial usage is FileDataObject. In cases where 
         * creating a simple file:// or http:// URL for a file is difficult 
         * (e.g. for files inside compressed archives) the applications 
         * are encouraged to use conventions defined by Apache Commons 
         * VFS Project at http://jakarta.apache.org/ commons/ vfs/ 
         * filesystems.html. 
         */
        void setUrl( const Resource& value );

        /**
         * \return The URI of the property 'url'. 
         */
        static QUrl urlUri();



    protected:
        DataObject( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
