/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _UNIONOFEVENTJOURNALTODO_H_
#define _UNIONOFEVENTJOURNALTODO_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class RecurrenceRule;
    class AccessClassification;

}

#include "unionparentclass.h"

namespace NepomukFast {


    class UnionOfEventJournalTodo : public UnionParentClass
    {
    public:
        /**
         * Create a new empty and invalid UnionOfEventJournalTodo instance
         */
        UnionOfEventJournalTodo( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'created'. This property specifies the date and 
         * time that the calendar information was created by the calendar 
         * user agent in the calendar store. Note: This is analogous to 
         * the creation date and time for a file in the file system. Inspired 
         * by RFC 2445 sec. 4.8.7.1. Note that this property is a subproperty 
         * of nie:created. The domain of nie:created is nie:DataObject. 
         * It is not a superclass of UnionOf_Vevent_Vjournal_Vtodo, 
         * but since that union is conceived as an 'abstract' class, and 
         * in real-life all resources referenced by this property will 
         * also be DataObjects, than this shouldn't cause too much of a 
         * problem. Note that RFC allows ONLY UTC time values for this property. 
         */
        void setCreateds( const QList<QDateTime>& value );

        /**
         * Add a value to property 'created'. This property specifies 
         * the date and time that the calendar information was created 
         * by the calendar user agent in the calendar store. Note: This 
         * is analogous to the creation date and time for a file in the file 
         * system. Inspired by RFC 2445 sec. 4.8.7.1. Note that this property 
         * is a subproperty of nie:created. The domain of nie:created 
         * is nie:DataObject. It is not a superclass of UnionOf_Vevent_Vjournal_Vtodo, 
         * but since that union is conceived as an 'abstract' class, and 
         * in real-life all resources referenced by this property will 
         * also be DataObjects, than this shouldn't cause too much of a 
         * problem. Note that RFC allows ONLY UTC time values for this property. 
         */
        void addCreated( const QDateTime& value );

        /**
         * Set property 'created'. This property specifies the date and 
         * time that the calendar information was created by the calendar 
         * user agent in the calendar store. Note: This is analogous to 
         * the creation date and time for a file in the file system. Inspired 
         * by RFC 2445 sec. 4.8.7.1. Note that this property is a subproperty 
         * of nie:created. The domain of nie:created is nie:DataObject. 
         * It is not a superclass of UnionOf_Vevent_Vjournal_Vtodo, 
         * but since that union is conceived as an 'abstract' class, and 
         * in real-life all resources referenced by this property will 
         * also be DataObjects, than this shouldn't cause too much of a 
         * problem. Note that RFC allows ONLY UTC time values for this property. 
         */
        void setCreated( const QDateTime& value );

        /**
         * \return The URI of the property 'created'. 
         */
        static QUrl createdUri();

        /**
         * Set property 'class'. Defines the access classification for 
         * a calendar component. Inspired by RFC 2445 sec. 4.8.1.3 with 
         * the following reservations: this property has limited vocabulary. 
         * Possible values are: PUBLIC, PRIVATE and CONFIDENTIAL. The 
         * default is PUBLIC. Those values are expressed as instances 
         * of the AccessClassification class. The user may create his/her 
         * own if necessary. 
         */
        void setClasses( const QList<AccessClassification>& value );

        /**
         * Add a value to property 'class'. Defines the access classification 
         * for a calendar component. Inspired by RFC 2445 sec. 4.8.1.3 
         * with the following reservations: this property has limited 
         * vocabulary. Possible values are: PUBLIC, PRIVATE and CONFIDENTIAL. 
         * The default is PUBLIC. Those values are expressed as instances 
         * of the AccessClassification class. The user may create his/her 
         * own if necessary. 
         */
        void addClass( const AccessClassification& value );

        /**
         * Set property 'class'. Defines the access classification for 
         * a calendar component. Inspired by RFC 2445 sec. 4.8.1.3 with 
         * the following reservations: this property has limited vocabulary. 
         * Possible values are: PUBLIC, PRIVATE and CONFIDENTIAL. The 
         * default is PUBLIC. Those values are expressed as instances 
         * of the AccessClassification class. The user may create his/her 
         * own if necessary. 
         */
        void setClass( const AccessClassification& value );

        /**
         * \return The URI of the property 'class'. 
         */
        static QUrl classUri();

        /**
         * Set property 'ncalRelation'. A common superproperty for all 
         * types of ncal relations. It is not to be used directly. 
         */
        void setNcalRelations( const QStringList& value );

        /**
         * Add a value to property 'ncalRelation'. A common superproperty 
         * for all types of ncal relations. It is not to be used directly. 
         */
        void addNcalRelation( const QString& value );

        /**
         * \return The URI of the property 'ncalRelation'. 
         */
        static QUrl ncalRelationUri();

        /**
         * Set property 'sequence'. This property defines the revision 
         * sequence number of the calendar component within a sequence 
         * of revisions. Inspired by RFC 2445 sec. 4.8.7.4 
         */
        void setSequences( const QList<qint64>& value );

        /**
         * Add a value to property 'sequence'. This property defines the 
         * revision sequence number of the calendar component within 
         * a sequence of revisions. Inspired by RFC 2445 sec. 4.8.7.4 
         */
        void addSequence( const qint64& value );

        /**
         * Set property 'sequence'. This property defines the revision 
         * sequence number of the calendar component within a sequence 
         * of revisions. Inspired by RFC 2445 sec. 4.8.7.4 
         */
        void setSequence( const qint64& value );

        /**
         * \return The URI of the property 'sequence'. 
         */
        static QUrl sequenceUri();

        /**
         * Set property 'relatedToSibling'. The property is used to represent 
         * a relationship or reference between one calendar component 
         * and another. Inspired by RFC 2445 sec. 4.8.4.5. Originally 
         * this property had a RELTYPE parameter. It has been decided that 
         * it is more natural to introduce three different properties 
         * to express the values of that parameter. This property expresses 
         * the RELATED-TO property with RELTYPE=SIBLING parameter. 
         */
        void setRelatedToSiblings( const QStringList& value );

        /**
         * Add a value to property 'relatedToSibling'. The property is 
         * used to represent a relationship or reference between one calendar 
         * component and another. Inspired by RFC 2445 sec. 4.8.4.5. Originally 
         * this property had a RELTYPE parameter. It has been decided that 
         * it is more natural to introduce three different properties 
         * to express the values of that parameter. This property expresses 
         * the RELATED-TO property with RELTYPE=SIBLING parameter. 
         */
        void addRelatedToSibling( const QString& value );

        /**
         * \return The URI of the property 'relatedToSibling'. 
         */
        static QUrl relatedToSiblingUri();

        /**
         * Set property 'relatedToChild'. The property is used to represent 
         * a relationship or reference between one calendar component 
         * and another. Inspired by RFC 2445 sec. 4.8.4.5. Originally 
         * this property had a RELTYPE parameter. It has been decided to 
         * introduce three different properties to express the values 
         * of that parameter. This property expresses the RELATED-TO 
         * property with RELTYPE=CHILD parameter. 
         */
        void setRelatedToChilds( const QStringList& value );

        /**
         * Add a value to property 'relatedToChild'. The property is used 
         * to represent a relationship or reference between one calendar 
         * component and another. Inspired by RFC 2445 sec. 4.8.4.5. Originally 
         * this property had a RELTYPE parameter. It has been decided to 
         * introduce three different properties to express the values 
         * of that parameter. This property expresses the RELATED-TO 
         * property with RELTYPE=CHILD parameter. 
         */
        void addRelatedToChild( const QString& value );

        /**
         * \return The URI of the property 'relatedToChild'. 
         */
        static QUrl relatedToChildUri();

        /**
         * Set property 'relatedToParent'. The property is used to represent 
         * a relationship or reference between one calendar component 
         * and another. Inspired by RFC 2445 sec. 4.8.4.5. Originally 
         * this property had a RELTYPE parameter. It has been decided that 
         * it is more natural to introduce three different properties 
         * to express the values of that parameter. This property expresses 
         * the RELATED-TO property with no RELTYPE parameter (the default 
         * value is PARENT), or with explicit RELTYPE=PARENT parameter. 
         */
        void setRelatedToParents( const QStringList& value );

        /**
         * Add a value to property 'relatedToParent'. The property is 
         * used to represent a relationship or reference between one calendar 
         * component and another. Inspired by RFC 2445 sec. 4.8.4.5. Originally 
         * this property had a RELTYPE parameter. It has been decided that 
         * it is more natural to introduce three different properties 
         * to express the values of that parameter. This property expresses 
         * the RELATED-TO property with no RELTYPE parameter (the default 
         * value is PARENT), or with explicit RELTYPE=PARENT parameter. 
         */
        void addRelatedToParent( const QString& value );

        /**
         * \return The URI of the property 'relatedToParent'. 
         */
        static QUrl relatedToParentUri();

        /**
         * Set property 'exrule'. This property defines a rule or repeating 
         * pattern for an exception to a recurrence set. Inspired by RFC 
         * 2445 sec. 4.8.5.2. 
         */
        void setExrules( const QList<RecurrenceRule>& value );

        /**
         * Add a value to property 'exrule'. This property defines a rule 
         * or repeating pattern for an exception to a recurrence set. Inspired 
         * by RFC 2445 sec. 4.8.5.2. 
         */
        void addExrule( const RecurrenceRule& value );

        /**
         * \return The URI of the property 'exrule'. 
         */
        static QUrl exruleUri();

        /**
         * Set property 'categories'. Categories for a calendar component. 
         * Inspired by RFC 2445 sec 4.8.1.2 with the following reservations: 
         * The LANGUAGE parameter has been discarded. Please use xml:lang 
         * literals to express multiple languages. This property can 
         * specify multiple comma-separated categories. The order of 
         * categories doesn't matter. Please use a separate triple for 
         * each category. 
         */
        void setCategorieses( const QStringList& value );

        /**
         * Add a value to property 'categories'. Categories for a calendar 
         * component. Inspired by RFC 2445 sec 4.8.1.2 with the following 
         * reservations: The LANGUAGE parameter has been discarded. 
         * Please use xml:lang literals to express multiple languages. 
         * This property can specify multiple comma-separated categories. 
         * The order of categories doesn't matter. Please use a separate 
         * triple for each category. 
         */
        void addCategories( const QString& value );

        /**
         * \return The URI of the property 'categories'. 
         */
        static QUrl categoriesUri();



    protected:
        UnionOfEventJournalTodo( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
